/**
 * @file Phase10Phase.h
 *
 * @brief Classes to describe phase
 *
 * @ingroup CommonTypes
 *
 * @author Devon Johnson
 *
 */

#pragma once

// Includes
#include <list>

#include <Phase10/CommonTypes.h>
#include <Phase10/Deck.h>

namespace Phase10
{
  //-------------------------------------------------------------------------//
  // Class:       Phase
  // Description: Phase with multiple matches
  //-------------------------------------------------------------------------//
  class Phase
  {
  public:
    // Public types
    using DeckListener = typename Deck::Listener;
    using MatchList    = std::list<sMatch>;

    ///////////////////////////////////////////////////////////////////////////
    /// @brief Destructor
    ///////////////////////////////////////////////////////////////////////////
    virtual ~Phase() = default;

    ///////////////////////////////////////////////////////////////////////////
    /// @brief Adds a listener for all matches in the phase
    /// @return - None
    ///////////////////////////////////////////////////////////////////////////
    void addListener(const DeckListener& listener);

    ///////////////////////////////////////////////////////////////////////////
    /// @brief Creates a phase for the phase number
    /// @param phaseNum - phase number
    /// @return - initial phase
    ///////////////////////////////////////////////////////////////////////////
    static sPhase create(PhaseNumber phaseNum);

    ///////////////////////////////////////////////////////////////////////////
    /// @brief Gets the phase data
    /// @param msg[out] - phase data
    /// @return - None
    ///////////////////////////////////////////////////////////////////////////
    void getPhase(Messages::PhaseMsg& msg) const;

    ///////////////////////////////////////////////////////////////////////////
    /// @brief Determines if phase is complete
    /// @return - true if complete, else false
    ///////////////////////////////////////////////////////////////////////////
    bool isComplete() const;

    ///////////////////////////////////////////////////////////////////////////
    /// @brief Determines if the phase is locked for editing
    /// @return - true if locked, else false
    ///////////////////////////////////////////////////////////////////////////
    bool isLocked() const;

    ///////////////////////////////////////////////////////////////////////////
    /// @brief Gets the matches
    /// @return - matches
    ///////////////////////////////////////////////////////////////////////////
    const MatchList& matches() { return mMatches; }

    ///////////////////////////////////////////////////////////////////////////
    /// @brief Passes all the cards from the phase to the given deck
    /// @param deck[i/o] - deck to pass to
    /// @return - true if passed, else false
    ///////////////////////////////////////////////////////////////////////////
    bool passAll(Deck& deck);

    ///////////////////////////////////////////////////////////////////////////
    /// @brief Sets the phase data
    /// @param msg - phase data
    /// @return - None
    ///////////////////////////////////////////////////////////////////////////
    void setPhase(const Messages::PhaseMsg& msg);

  private:
    // Allow Player to call setLocked
    friend class Player;

    // Private class variables
    MatchList mMatches; ///< matches for this phase

    ///////////////////////////////////////////////////////////////////////////
    /// @brief Constructor
    /// @param matches - matches involved in this phase
    ///////////////////////////////////////////////////////////////////////////
    Phase(MatchList&& matches);

    ///////////////////////////////////////////////////////////////////////////
    /// @brief Sets whether the deck is locked for editing
    /// @param locked - true if locked, else false
    /// @return - None
    ///////////////////////////////////////////////////////////////////////////
    void setLocked(bool locked);
  };

} // namespace Phase10
